// oCADis (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __TOOL_MULTISELECT_H_
#define __TOOL_MULTISELECT_H_

#include "tool_state.h"
#include "tool.h"
#include "document.h"

class StateMultiSelect : public ToolState
{
public:
	StateMultiSelect( Tool* tool, ToolboxSideBar* parent );
	~StateMultiSelect();

	void PointSelected( Canvas* canvas, Document* doc, os::Point coord );
	bool AllowMouseBox( Canvas* canvas, Document* doc, os::Point coord );
	void MouseBox( Canvas* canvas, Document* doc, os::Rect box );

	os::String GetStatusText();

	virtual void SetFrame( const os::Rect& cRect, bool bNotifyServer = true );
	virtual void HandleMessage( Canvas* canvas, Document* doc, os::Message* pcMessage );

	void AllAttached( void );

	virtual void SelectionDone( Canvas* canvas, Document* doc );

private:
	class Private;
	Private* m;
};

#endif
